## Copyright (C) 2018 jdonoghue
## 
## This program is free software: you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program.  If not, see
## <https://www.gnu.org/licenses/>.

## -*- texinfo -*- 
## @deftypefn {} {@var{ret} = } isTerminalAnalog (@var{obj}, @var{terminal})
## Return true if pin is capanle of analog input
##
## @var{ar} - the connected arduino object
## @var{terminal} is a terminal number ot check
## @var{ret} return 1 of is a analog pin, 0 otherwise
## @end deftypefn

function retvalue = isTerminalAnalog (obj, terminal)
  if nargin < 2
    show_usage();
  endif

  pininfo = obj.get_pin(terminal);
  
  idx = find( cellfun(@(x) strcmpi(x, "analog"), pininfo.modes), 1);
  
  if isempty(idx)
    retvalue = 0;
  else
   retvalue = 1;
  endif
  
endfunction
