# private function
function retval = __digitalPin__(obj, pin, value)
  ARDUINO_DIGITAL = 3;

  retval = 0;

  if !ischar(pin) && !isnumeric(pin)
    error ("@arduino.digitalPin: expected pin name as string");
  endif

  pininfo = obj.get_pin(pin);

  if nargin == 2
    mode = "digitalinput";
    datain = uint8([pininfo.id]);
  elseif nargin == 3
    mode = "digitaloutput";
    if value
      val = 1;
    else
      val = 0;
    endif
  
    datain = uint8([pininfo.id val]);
 
  endif

  # first use ?
  if strcmp(pininfo.mode, "unset")
    configurePin(obj, pin, mode)
  else
    [pinstate, pinmode] = pinStateMode(pininfo.mode);
    if !strcmp(pinmode, "digital")
      error ("digitalPin: pin is in incompatable mode");
    endif
  endif
 
  [dataout, status] = __sendCommand__ (obj, ARDUINO_DIGITAL, datain);
  if status != 0
    error ("digitalPin: failed to set/get pin state err=%d", status);
  endif 
 
  if nargin == 2
 
    if dataout(2) != 0
      retval = 1;
    else
      retval = 0;
    endif
  endif
endfunction
