classdef i2cdev < handle
  properties
   arduinoobj = []
   pins = []
   address = []
   bus = 0;
  endproperties

  % readRegister(dec, 20, type('uint8' is default) can be u/i 8/16)
  % writeRegister(dev, 20, dataIn, [type]) datain can be a single num or vector
  % read(dev, cnt, [type])
  % write(dev, dataIn, precicion)

  methods
    %function p = spidev(ar, address, [props])
    function p = i2cdev(varargin)
      ARDUINO_I2C_CONFIG = 21;

      % Bus X (for where more than 1 i2c port)

      if nargin < 2
	error("expects arduino object and chipselect pin");
      endif

      ar = varargin{1};
      address = varargin{2};
      bus = 0;

	if !isnumeric(address) || address < 0 || address > 255
	  error("expected address between 0 .. 255");
	endif

	if mod(nargin, 2) != 0
          error ("arduino: expected property name, value pairs");
        endif
        if !iscellstr (varargin(3:2:nargin))
          error ("arduino: expected property names to be strings");
        endif

	for i = 3:2:nargin
          propname = tolower(varargin{i});
          propvalue = varargin{i+1};

	  printf("%s = %s\n", propname, propvalue);
	  if propname == "bus"
	    if !isnumeric(propvalue) || propvalue < 0
              error("bus should be a positive number")
	    endif
	    bus = propvalue;
          endif

        endfor


      if (!isa (ar, "arduino"))
       error("expects arduino object");
      endif

       p.address = address;
       p.arduinoobj = ar;
       p.bus = bus;

       % TODO on calling setup with the CS pin, returns back the other pins that we then setup as used ?
       % sendCommand
       # there only ever one port ??? with CS able to be completely independant ??
       name = "i2c_";
       if bus > 0
         name = ["i2c" num2str(bus) "_"]; 
       endif
       p.pins = ar.get_group(name);
       if numel(p.pins) != 2
	  error("expected 2 I2C pins but only have %d", numel(p.pins) )
       endif

       # TODO: save old modes and set them via force if we fail trying to alloc the whole group
       try
        for i=1:2
          configurePin(ar, p.pins{i}.name, "i2c")
	  #if (strcmpi(p.pins{i}.func, "ss"))
          #  p.chipselectpin = p.pins{i}.name;
	  #  # overwride mode for digital out
	  #  configurePinResource(ar, p.pins{i}.name, getResourceOwner(ar, p.pins{i}.name), "digitaloutput", true);
	  #endif
        endfor
        # TODO: bitrate
	bitorder = 0;
        [tmp, sz] = sendCommand(p.arduinoobj, "", ARDUINO_I2C_CONFIG, [bus 1]);
       catch
        for i=1:2
          configurePinResource(ar, p.pins{i}.name, p.pins{i}.owner, p.pins{i}.mode, true)
          configurePin(ar, p.pins{i}.name, p.pins{i}.mode)
        endfor
        rethrow (lasterror)
       end_try_catch

    endfunction

    function disp (p)
      printf ("  arduino i2cdev object with fields of: \n\n");
      printf ("         address = %d (0x%02X)\n", p.address, p.address);
      printf ("             bus = %d\n", p.bus);
      printf ("            pins = ");
      for i=1:2
	printf("%s(%s) ", p.pins{i}.name, p.pins{i}.func)
      endfor
     printf("\n");
     % Mode, Bitrate, Bitorder
     
      printf ("\n");
    endfunction

  endmethods
endclassdef
