classdef servo < handle
  properties
   arduinoobj = [];
   pins = { "none" };
   minpulseduration = 5.44e-04;
   maxpulseduration = 2.40e-03;
  endproperties

  methods
    %function p = spidev(ar, cspin)
    function p = servo(varargin)
      ARDUINO_SERVO_CONFIG = 31;

      if nargin < 2
	error("expects arduino object and servo pin");
      endif

      ar = varargin{1}
      pin = varargin{2}

      ar.set_debug(true);

       p.pins = {};
       p.pins{end+1} = pin

	if mod(nargin, 2) != 0
          error ("arduino: expected property name, value pairs");
        endif
        if !iscellstr (varargin(3:2:nargin))
          error ("arduino: expected property names to be strings");
        endif

	for i = 3:2:nargin
          propname = tolower(varargin{i});
          propvalue = varargin{i+1};

	  printf("%s = %s\n", propname, propvalue);
	  if propname == "minpulseduration"
	    if !isnumeric(propvalue)
              error("minpulseduration should be a number")
	    endif
	    p.minpulseduration = propvalue;
          elseif propname == ""maxpulseduration
	    if !isnumeric(propvalue)
              error("maxpulseduration should be a number")
	    endif
	    p.maxpulseduration = propvalue;
          endif

        endfor


      if (!isa (ar, "arduino"))
       error("expects arduino object");
      endif

       p.arduinoobj = ar

       validatePin(ar,pin,'servo')

       configurePin(ar, p.pins{i}.name, "servo")

       pininfo = ar.get_pin(pin)
       sendCommand(ar, "", ARDUINO_SERVO_CONFIG, [pininfo.id]);
    endfunction

    function disp (p)
      printf ("  arduino servo object with fields of: \n\n");
      printf ("                pins = %s\n", p.pins{1} );
      printf ("    minpulseduration = %f\n", p.minpulseduration);
      printf ("    maxpulseduration = %f\n", p.maxpulseduration);
     
      printf ("\n");
    endfunction

  endmethods
endclassdef
